;;  -------------------------------------------------------------------
;;  NOM:        INT2STR.ASM
;;  CREAT PER:  Sergio Blanco Cuaresma
;;		Francesc Galiano Baixauli
;;  DATA:       03/05/2001
;;  DESCRIPCIO: acci realitza la conversi d'un nmero enter de
;;              16 bits a un string (cadena de carcters) amb la seva
;;              representacio ASCII. **Corregida**
;;  -------------------------------------------------------------------

;       A continuaci s'acostuma a posar les DECLARACIONS "PUBLIQUES":
;       quines dades i funcions s'han de "veure" externament

PUBLIC _Integer2String

;       Segments de dades: _DATA (inicialitzades) i _BSS (no inicialitzades)

_DATA   SEGMENT WORD PUBLIC 'DATA'
                        ; en aquest segment el Turbo C hi posa
                        ; les dades inicialitzades
_DATA   ENDS

_BSS    SEGMENT WORD PUBLIC 'BSS'
                            ; en aquest segment el Turbo C hi posa
                            ; les dades no inicialitzades.
                            ; MOLT DE COMPTE!! no s'han de posar dades
                            ; inicialitzades, doncs de vegades el Turbo C
                            ; inicialitza aquest segment TOT A ZEROS
_BSS    ENDS

        ; els dos segments anteriors s'uneixen en un sol grup: DGROUP
DGROUP  GROUP   _DATA, _BSS

        ; declaraci d'on es suposa que apunten els registres de segment
ASSUME cs:Codi, ds:DGROUP


        ; segment de codi: pot tenir qualsevol nom (el segment, no el que
        ; posa 'CODE') per ha d'estar definit de la segent forma:

Codi SEGMENT BYTE PUBLIC 'CODE'

_Integer2String PROC FAR
        push    bp      ; BP es modificar
        mov     bp,sp   ; E. dinamic per acces a params. i vars. locals
        		; ATENCION!! la siguiente instruccion deberia ser "sub sp,4", aunque
        		; solo vayamos a utilizar 1 byte del ultimo word, es asi como se trabaja
        sub     sp,3	; espai a la pila per variables locals (2bits [num] + 1bit [signe])
        push    ax     	; salvar registres que es modificaran
        push	bx
        push	es
        push	si
        push	cx
        
        mov	ax, [bp+6]		;Variable Numero
        cmp	ax, 0			;Si es negatiu, ho guardem i li canviem el signe
        jge	sino
	neg	ax
	mov	[bp-2], ax
	mov	[bp-3], byte ptr '-'
	jmp	fsi
sino:	mov	[bp-2], ax		;Si el num es positiu
	mov	[bp-3], byte ptr ' '
fsi:
	mov	bx, [bp+8]		;OFFSET de Resultat
        mov	es, [bp+10]		;SEGMENT de Resultat
        mov	es:[bx+5], byte ptr 0	;Final de l'string
        mov	si, 5
        mov	cx, 10 			;Per fer la division /10
repetir:
	xor	dx, dx			;div -> dx:ax / source -> ax (resto->dx)
        div	cx
        add	dx, '0'			;tranformen a codi ascii
        mov	es:[bx+si],dl		;el guardem
        dec	si			;Seguent posicio
        cmp	ax,0
        jne	repetir
        
        mov	cl, [bp-3]		;Afegim el signe
        mov	es:[bx+si], cl
        dec	si
mentre:
  	cmp	si,0			;La resta d'espais els posem en blanc
        jl	fmentre
        mov	es:[bx+si], byte ptr ' '
        dec	si
        jmp	mentre
fmentre:
	pop	cx     	; restaurar registres modificats per la rutina
	pop     si
        pop	es
        pop	bx
        pop	ax
        mov     sp,bp   ; recupera l'espai ocupat per variables locals
        pop     bp      ; recupera BP anterior
        ret             ; retorna. NO S'HAN DE TREURE ELS PARAMETRES !!!
_Integer2String ENDP

Codi ENDS

        END     ; final de fitxer